using System;
using System.Collections.Generic;

namespace Examples.ExtensionMethod
{
    public static class StringExtensions
    {
        public static IEnumerable<string> WordWrap(this string str, int? lineLength)
        {

            List<string> wrappedText = new List<string>();

            if(lineLength == null || lineLength <= 0)
            {
                wrappedText.Add(str);
                return wrappedText;
            }

            string[] splitText = str.Split(' ');

            var buildstring = String.Empty;
            foreach (var text in splitText)
            {
                if ((buildstring + " " + text).Length > lineLength)
                {
                    wrappedText.Add(buildstring);
                    buildstring = text;
                }
                else
                {
                    buildstring = buildstring + " " + text;
                }

            }

            return wrappedText;
        }
    }
}