﻿using System;
using System.Collections.Generic;
using System.IO;

namespace Examples.ExtensionMethod
{
    class Program
    {
        static void Main(string[] args)
        {
            FileStream fileStream = new FileStream("sampleText.txt", FileMode.Open);
            using (StreamReader reader = new StreamReader(fileStream))
            {
                var lines = reader.ReadLine().WordWrap(100);
                Console.WriteLine("\n\n");
                foreach (var line in lines)
                {
                    Console.WriteLine(line);
                }

            }
            Console.WriteLine("\n\nPress any key to contine.");
            Console.ReadLine();
        }
    }
}

